﻿/*
====== READ THIS ========
This code was created as a part of the seminar on 
flash game programing at the University of Munich (Ludwig-
Maximlians Universität.

The code may be used for educational purposes only. All
rights reserverd by the author.

Author: Max Maurer
E-Mail: max.maurer@ifi.lmu.de
(c) 2011
If you have any questions don't hasitate to contact me.
=========================
*/package {
	import flash.display.MovieClip;
	public class Snake extends MovieClip {
		static const DIR_RIGHT:int=1;
		static const DIR_LEFT:int=2;
		static const DIR_UP:int=3;
		static const DIR_DOWN:int=4;
		public var parts:Array;
		public var direction:int;
		public var moveEvery:int;
		private var moveCount:int;
		private var nextDirection:int;
		
		public function Snake():void {
		}
		
		public function reset():void {
			while (numChildren>0) removeChildAt(0);
			parts = new Array();
			createPartAt(10,10);
			appendPart();
			appendPart();
			direction=DIR_UP;
			nextDirection=DIR_UP;
			moveEvery = 10;
			moveCount=0;
		}
		
		public function hitSelf():Boolean {
			var head:SnakePart = parts[0];
			var p:SnakePart;
			var stillHead:Boolean = true; // while the first parts are still benath each other don't use them
			for (var i:int=1;i<parts.length;i++) {
				p = parts[i];
				if (head.px == p.px && head.py == p.py) {
					if (!stillHead) return true;
				} else stillHead=false;
			}
			return false;
		}
		
		public function getPosition():Object {
			return parts[0].getPosition();
		}
		
		private function createPartAt(px:int,py:int):void {
			var part:SnakePart = new SnakePart();
			addChild(part);
			part.setPosition(px,py);
			parts.push(part);
		}
		
		public function appendPart():void {
			var lastPart:SnakePart = parts[parts.length-1];
			createPartAt(lastPart.px, lastPart.py);
		}
		
		public function setDirection(dir:int):void {
			if ((dir==DIR_UP && direction==DIR_DOWN) || (dir==DIR_DOWN && direction==DIR_UP) || (dir==DIR_LEFT && direction==DIR_RIGHT)|| (dir==DIR_RIGHT && direction==DIR_LEFT)) return;
			nextDirection=dir;
		}
		
		public function move():void {
			moveCount++;
			if (moveCount>=moveEvery) {
				moveCount=0;
				direction=nextDirection;
				// bring the last snake part forward
				var setPart:SnakePart = parts[parts.length-1];
				var curX:int = parts[0].px;
				var curY:int = parts[0].py;
				if (direction==DIR_RIGHT) {
					setPart.setPosition(curX+1,curY);
				} else if (direction==DIR_LEFT) {
					setPart.setPosition(curX-1,curY);
				} else if (direction==DIR_DOWN) {
					setPart.setPosition(curX,curY+1);
				} else {
					setPart.setPosition(curX,curY-1);
				}
				parts.unshift(parts.pop());
			}
		}
	}
}