﻿/*
====== READ THIS ========
This code was created as a part of the seminar on 
flash game programing at the University of Munich (Ludwig-
Maximlians Universität.

The code may be used for educational purposes only. All
rights reserverd by the author.

Author: Max Maurer
E-Mail: max.maurer@ifi.lmu.de
(c) 2011
If you have any questions don't hasitate to contact me.
=========================
*/package {
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.text.TextField;
	public class SnakeField extends MovieClip {
		private var snake:Snake;
		private var apple:Apple;
		private var fieldWidth:int=20;
		private var fieldHeight:int=20;
		private var apples:int;
		private var lives:int;
		
		public function SnakeField():void {
			snake=new Snake();
			addChild(snake);
			Key.init(stage);
			apple = new Apple();
			addChild(apple);
			resetGame();
			addEventListener(Event.ENTER_FRAME, enterFrameHandler);
		}
		
		public function resetGame():void {
			lives=3;
			apples=0;
			snake.reset();
			placeApple();
			updateUi();
		}
		
		private function placeApple():void {
			apple.setPosition(Math.floor(Math.random()*20),Math.floor(Math.random()*20));
		}
		
		private function enterFrameHandler(evt:Event):void {
			if (Key.isDown(38)) snake.setDirection(Snake.DIR_UP);
			else if (Key.isDown(37)) snake.setDirection(Snake.DIR_LEFT);
			else if (Key.isDown(39)) snake.setDirection(Snake.DIR_RIGHT);
			else if (Key.isDown(40)) snake.setDirection(Snake.DIR_DOWN);
			checkWallCollission();
			checkApple();
			snake.move();
		}
		
		private function checkWallCollission():void {
			var sPos = snake.getPosition();
			if (sPos.px>=fieldWidth || sPos.px<0 || sPos.py>=fieldHeight || sPos.py<0 || snake.hitSelf()) {
				lives--;
				if (lives<0) resetGame();
				snake.reset();
				updateUi();
			}
		}
		
		private function updateUi():void {
			txtLives.text = ""+lives;
			txtApples.text = ""+apples;
		}
		
		private function checkApple():void {
			var aPos = apple.getPosition();
			var sPos = snake.getPosition();
			if (aPos.px == sPos.px && aPos.py == sPos.py) {
				apples++;
				placeApple();
				if (snake.moveEvery>2) snake.moveEvery--; 
				snake.appendPart();
				updateUi();
			}
		}
	}
}